// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from fuse_msgs:msg/SerializedGraph.idl
// generated code does not contain a copyright notice
#include "fuse_msgs/msg/detail/serialized_graph__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `plugin_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
fuse_msgs__msg__SerializedGraph__init(fuse_msgs__msg__SerializedGraph * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    fuse_msgs__msg__SerializedGraph__fini(msg);
    return false;
  }
  // plugin_name
  if (!rosidl_runtime_c__String__init(&msg->plugin_name)) {
    fuse_msgs__msg__SerializedGraph__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    fuse_msgs__msg__SerializedGraph__fini(msg);
    return false;
  }
  return true;
}

void
fuse_msgs__msg__SerializedGraph__fini(fuse_msgs__msg__SerializedGraph * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // plugin_name
  rosidl_runtime_c__String__fini(&msg->plugin_name);
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
}

bool
fuse_msgs__msg__SerializedGraph__are_equal(const fuse_msgs__msg__SerializedGraph * lhs, const fuse_msgs__msg__SerializedGraph * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // plugin_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->plugin_name), &(rhs->plugin_name)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
fuse_msgs__msg__SerializedGraph__copy(
  const fuse_msgs__msg__SerializedGraph * input,
  fuse_msgs__msg__SerializedGraph * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // plugin_name
  if (!rosidl_runtime_c__String__copy(
      &(input->plugin_name), &(output->plugin_name)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

fuse_msgs__msg__SerializedGraph *
fuse_msgs__msg__SerializedGraph__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__msg__SerializedGraph * msg = (fuse_msgs__msg__SerializedGraph *)allocator.allocate(sizeof(fuse_msgs__msg__SerializedGraph), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(fuse_msgs__msg__SerializedGraph));
  bool success = fuse_msgs__msg__SerializedGraph__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
fuse_msgs__msg__SerializedGraph__destroy(fuse_msgs__msg__SerializedGraph * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    fuse_msgs__msg__SerializedGraph__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
fuse_msgs__msg__SerializedGraph__Sequence__init(fuse_msgs__msg__SerializedGraph__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__msg__SerializedGraph * data = NULL;

  if (size) {
    data = (fuse_msgs__msg__SerializedGraph *)allocator.zero_allocate(size, sizeof(fuse_msgs__msg__SerializedGraph), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = fuse_msgs__msg__SerializedGraph__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        fuse_msgs__msg__SerializedGraph__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
fuse_msgs__msg__SerializedGraph__Sequence__fini(fuse_msgs__msg__SerializedGraph__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      fuse_msgs__msg__SerializedGraph__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

fuse_msgs__msg__SerializedGraph__Sequence *
fuse_msgs__msg__SerializedGraph__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__msg__SerializedGraph__Sequence * array = (fuse_msgs__msg__SerializedGraph__Sequence *)allocator.allocate(sizeof(fuse_msgs__msg__SerializedGraph__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = fuse_msgs__msg__SerializedGraph__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
fuse_msgs__msg__SerializedGraph__Sequence__destroy(fuse_msgs__msg__SerializedGraph__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    fuse_msgs__msg__SerializedGraph__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
fuse_msgs__msg__SerializedGraph__Sequence__are_equal(const fuse_msgs__msg__SerializedGraph__Sequence * lhs, const fuse_msgs__msg__SerializedGraph__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!fuse_msgs__msg__SerializedGraph__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
fuse_msgs__msg__SerializedGraph__Sequence__copy(
  const fuse_msgs__msg__SerializedGraph__Sequence * input,
  fuse_msgs__msg__SerializedGraph__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(fuse_msgs__msg__SerializedGraph);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    fuse_msgs__msg__SerializedGraph * data =
      (fuse_msgs__msg__SerializedGraph *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!fuse_msgs__msg__SerializedGraph__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          fuse_msgs__msg__SerializedGraph__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!fuse_msgs__msg__SerializedGraph__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
